#ifdef WIN32 //if using windows then do windows specific stuff.
#define WIN32_LEAN_AND_MEAN //remove MFC overhead from windows.h witch can cause slowness
#define WIN32_EXTRA_LEAN

#include <windows.h>
#endif


#include "Triangle.h"
#include "Line.h"
#include <fstream>
#include <iostream>
#include <vector>
#include <gl/gl.h>
#include <gl/glut.h>
#include <gl/glu.h>

using namespace std;

void LoadPartOne( vector<Triangle>& triangles, vector<Line>& lines, char* filename);

void setup() { 
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    //glViewport (0, 0, 1600, 1200);
}

void display() { 
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   
	vector<Triangle> triangles;
	vector<Line> lines;
	LoadPartOne(triangles, lines, "example1.txt");
	//gluLookAt (1.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
	glScalef (0.5, 0.5, 0.5);
	glTranslatef(-1.5,-1.5,0.0); 
	for(int i=0; i<triangles.size(); i++)
	{
		glBegin(GL_POLYGON);
		for(int j=0; j<3; j++)
		{
			glColor4f(triangles[i].v[j].color.r, triangles[i].v[j].color.g, triangles[i].v[j].color.b, triangles[i].v[0].color.a);
			glVertex2f(triangles[i].v[j].pos.e[0], triangles[i].v[j].pos.e[1]);
		}
		glEnd();
	}
	for(int i=0; i<lines.size(); i++)
	{
		glBegin(GL_LINES);
		for(int j=0; j<2; j++)
		{
			glColor4f(lines[i].v[j].color.r, lines[i].v[j].color.g, lines[i].v[j].color.b, lines[i].v[j].color.a);
			glVertex2f(lines[i].v[j].pos.e[0], lines[i].v[j].pos.e[1]);
		}
		glEnd();
	}

    glutSwapBuffers();

}

int main(int argc, char *argv[])
{
        glutInit(&argc, argv);
        glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE);
        glutInitWindowSize(800,600);
        glutCreateWindow("COMP 770 - Rasterization with Open GL");
        
		setup();
		glutDisplayFunc(display);
        
		glutMainLoop();
        return 0;
}


void LoadPartOne( vector<Triangle>& triangles, vector<Line>& lines, char* filename)
{
	string line;
	ifstream file(filename);
	if(file.is_open())
	{
		int numTriangles = 0;
		file >> numTriangles;
		//cout << "numTriangles=" << numTriangles << endl;
		int x = 0; 
		int y = 0;
		int r = 0;
		int g = 0; 
		int b = 0;
		int a = 0;
		for(int i=0; i<numTriangles; i++)
		{	
			Vertex v[3];
			for(int j=0; j<3; j++)
			{
				file >> x;
				file >> y;
				file >> r;
				file >> g;
				file >> b;
				file >> a;
				//cout << "trivert=" << x << "," << y << "," << r << "," << g << "," << b << "," << a << endl;
				v[j] = Vertex(x,y,1.0,Color(r,g,b,a)); //need to avoid duplication here eventually ??
			}
			triangles.push_back(Triangle(v[0], v[1], v[2]));
		}
		int numLines = 0;
		file >> numLines;
		//cout << "numLines=" << numLines;
		Vertex v[2];
		for(int i=0; i<numLines; i++)
		{
			for(int j=0; j<2; j++)
			{
				file >> x;
				file >> y;
				file >> r;
				file >> g;
				file >> b;
				file >> a;
				//cout << "linevert=" << x << "," << y << "," << r << "," << g << "," << b << "," << a << endl;
				v[j] = Vertex(x,y,1.0,Color(r,g,b,a));
			}
			lines.push_back(Line(v[0], v[1]));
		}
	}
	else
	{
		cout << "Couldn't open file";
	}
}

/*#include <gl/GL.h>
#include <gl/GLU.h>
//#include "aux.h"

//#define drawOneLine(x1,y1,x2,y2) glBegin(GL_LINES); \
//	glVertex2f ((x1),(y1)); glVertex2f ((x2,(y2)); glEnd();


void myinit (void)
{
	//background to be cleared to black
	glClearColor(0.0,0.0,0.0,0.0);
	glShadeModel(GL_FLAT);
}

void display(void)
{
	int i;

	glClear (GL_COLOR_BUFFER_BIT);
	//draw all lines in  white
	glColor3f (1.0,1.0,1.0);

	//first row 3 lines each with a different stipple
	glEnable(GL_LINE_STIPPLE);
	glLineStipple(1, 0x0101); //dotted
	drawOneLine(50.0, 125.0, 150.0, 125.0);
	glLineStipple (1, 0x))FF); // dashed
	drawOneLine(150.0, 125.0, 250.0, 125.0);
	glLineStipple(1, 0x1C47); //dash dot dash
	drawOneLine(250.0, 125.0, 350.0, 125.0);

	// in 2nd row, 3 wide lines each with different stipple
}

int main (int argc, char** argv)
{
	auxInitDisplayMode(AUX_SINGLE | AUX_RGBA);
	auxInitPosition (0,0,400,150);
	auxInitWindow(arg[0]);
	myinit();
	auxMainLoop(display);
}*/