#include "ImageBuffer.h"
#include "EasyBMP.h"

ImageBuffer::ImageBuffer()
{
	// do nothing
}

ImageBuffer::ImageBuffer(int width, int height)
{
	w = width;
	h = height;

	raster = new Color*[w];
	zbuffer = new float*[w];
	for(int i=0; i<w; i++)
	{
		raster[i] = new Color[h];
		zbuffer[i] = new float[h];
		for(int j=0; j<h; j++)
		{
			zbuffer[i][j] = 10000000000000.0; //some big float
			raster[i][j] = Color(0.3,0.3,0.3,1.0); //background color
		}
	}
}

/*ImageBuffer::ImageBuffer(int width, int height, Color background)
{
	
}*/

bool ImageBuffer::set(int x, int y, float z, const Color& color)
{
	if(0 > x || x >= w) 
	{
		return false;
	}
	if(0 > y || y >= h)
	{
		return false;
	}
	if(z < zbuffer[x][y])
	{
		zbuffer[x][y] = z;
		raster[x][y] = color;
	}
}

void ImageBuffer::writeBMP(char* filename)
{
	BMP output;
	output.SetSize(w, h);
	output.SetBitDepth(32);
	unsigned int ired, igreen, iblue, ialpha;
	for(int j=0; j<h; j++)
	{
		for(int i=0; i < w; i++)
		{
			//clamp to 0 to 255
			ired = (unsigned int)(256*raster[i][j].r);
			igreen = (unsigned int)(256*raster[i][j].g);
			iblue = (unsigned int)(256*raster[i][j].b);
			ialpha = (unsigned int)(256*raster[i][j].a);
			if(ired > 255)
			{
				ired = 255;
			}
			if(igreen > 255)
			{
				igreen = 255;
			}
			if(iblue > 255)
			{
				iblue = 255;
			}
			if(ialpha > 255)
			{
				ialpha = 255;
			}
			output(i,h-j-1)->Red = ired;
			output(i,h-j-1)->Green = igreen;
			output(i,h-j-1)->Blue = iblue;
			output(i,h-j-1)->Alpha = ialpha;
		}
	}
	output.WriteToFile(filename);
}