#ifndef _NORMAL_H_
#define _NORMAL_H_

/// A class representing a normal in 3D space.
class Normal
{
	public:
		
		/// Construct a default normal pointing in the positive X direction.
		inline Normal()
			:	x( 0.0f ),
				y( 0.0f ),
				z( 0.0f )
		{
		}
		
		
		/// Construct a default normal pointing in the given direction.
		inline Normal( float newX, float newY, float newZ )
			:	x( newX ),
				y( newY ),
				z( newZ )
		{
		}
		
		
		/// 3D direction of the normal.
		float x, y, z;
		
		
};

#endif //_NORMAL_H_